This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 786860 - Review Request: opa - Opa, AGPL language for web 2.0 [NEEDINFO]
Review Request: opa - Opa, AGPL language for web 2.0
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
:
: 786634 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-02-02 10:28 EST by rudy.sicard
Modified: 2014-01-16 04:53 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-11-22 02:28:12 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
i: needinfo? (rudy.sicard)


Attachments (Terms of Use)

  None (edit)
Description rudy.sicard 2012-02-02 10:28:42 EST
Spec URL: 
http://download.opalang.org/fedora-package-candidate/opa.spec

SRPM URL: 
http://download.opalang.org/fedora-package-candidate/opa-0.9.0-1.fc17.src.rpm
Spec URL: http://uploading.com/files/d2ab4686/opa.spec

Description:

Opa is a unified programming language for web development. This package
contains the Opa compiler, that compiles stand-alone web servers including AJAX
features, database, etc. from single source files.

(see opalang.org)

It is my first package submission and I am seeking a sponsor.
My name is Rudy Sicard, and I am working for the company that created the
language (MLstate).

rpmlint output:
opa.spec: W: invalid-url Source0: opalang.tar.gz
explanation:
opalang.org provides no source tarball (only binaries).
So I used github repository from generating the tarball (instruction are given
in the spec file to reproduce).
(tar ball generated by github are no compatible with rpm due to bad naming
scheme)
The tarball ban be download here to simplify the review.
Source : http://download.opalang.org/fedora-package-candidate/opalang.tar.gz


Remark, I have several comment where I think something is probably wrong.
(search for #PROBLEM in spec file)


ps: the dependency ocaml-cryptokit.fc17 is present in koji, but I cannot use it
on my fedora system via yum.
If you are in the same situation you can download directly the needed packages:
http://kojipkgs.fedoraproject.org/packages/ocaml-cryptokit/1.4/5.fc17/x86_64/ocaml-cryptokit-1.4-5.fc17.x86_64.rpm
http://kojipkgs.fedoraproject.org/packages/ocaml-cryptokit/1.4/5.fc17/x86_64/ocaml-cryptokit-devel-1.4-5.fc17.x86_64.rpm
Comment 1 Susi Lehtola 2012-02-02 14:30:00 EST
*** Bug 786634 has been marked as a duplicate of this bug. ***
Comment 2 Thomas Spura 2012-02-03 03:41:00 EST
(In reply to comment #0)
> It is my first package submission and I am seeking a sponsor.

Then please block FE-NEEDSPONSOR like stated here:
http://fedoraproject.org/wiki/How_to_get_sponsored_into_the_packager_group#Submitting_quality_new_packages

It seems, you haven't read that at all yet.
Comment 3 Mathieu Baudet 2012-02-06 11:13:50 EST
I believe Rudy is now in touch with Steven Dake to join the packager group.
Comment 4 Steven Dake 2012-02-19 15:03:44 EST
Rudy,

On your path to joining the packager group, please review the following bugzilla:

As you can see there are several comments in the review.  Please do a new review of the current package and work with the packager to get all of the review guidelines met.

The bugzilla is:
https://bugzilla.redhat.com/show_bug.cgi?id=772608
Comment 5 Gal Hammer 2012-02-26 04:43:53 EST
I am not in the package reviewer group, but have provided this review
as part of my sponsorship process.  As a result, this notifies future
reviewers that the review should be verified.

[PASS] MUST: rpmlint must be run on the source rpm and all binary rpms the
build produces. The output should be posted in the review.

$ rpmlint opa.spec
opa.spec:106: W: macro-in-comment %buildroot
opa.spec: W: invalid-url Source0: opalang.tar.gz
0 packages and 1 specfiles checked; 0 errors, 2 warnings.

I think the Source0 should be a URL and not just the file name.

$ rpmlint opa-0.9.0-1.fc17.src.rpm
opa.src: W: name-repeated-in-summary C Opa
opa.src: W: no-version-in-last-changelog
opa.src:106: W: macro-in-comment %buildroot
opa.src: W: invalid-url Source0: opalang.tar.gz
1 packages and 0 specfiles checked; 0 errors, 4 warnings.

I was unable to build the binary package using mock:

+ rm -rf /builddir/build/BUILD/usr
+ ./install_release.sh -no-doc -keep-build -keep-install-sys -srcdir . -dir /builddir/build/BUILD/usr
error: Bad exit status from /var/tmp/rpm-tmp.gqsfjf (%build)
    Bad exit status from /var/tmp/rpm-tmp.gqsfjf (%build)

[PASS] MUST: The package must be named according to the Package Naming
Guidelines.

[PASS] MUST: The spec file name must match the base package %{name}, in the
format %{name}.spec unless your package has an exemption.

[PASS] MUST: The package must meet the Packaging Guidelines.

[PASS] MUST: The package must be licensed with a Fedora approved license and
meet the Licensing Guidelines.

[PASS] MUST: The License field in the package spec file must match the actual
license.

[PASS] MUST: If (and only if) the source package includes the text of the
license(s) in its own file, then that file, containing the text of the
license(s) for the package must be included in %doc.

[PASS] MUST: The spec file must be written in American English.

[FAIL] MUST: The spec file for the package MUST be legible.

Can't you use %{_libdir} (or similar) macro?

No file names in %files section. I think "%{_bindir}/*" is too general and probably includes all under /usr/bin directory.

[PASS] MUST: The sources used to build the package must match the upstream
source, as provided in the spec URL. Reviewers should use md5sum for this task.
If no upstream URL can be specified for this package, please see the Source URL
Guidelines for how to deal with this.

[FAIL] MUST: The package MUST successfully compile and build into binary rpms
on at least one primary architecture.

[NA] MUST: If the package does not successfully compile, build or work
on an architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in
bugzilla, describing the reason that the package does not compile/build/work on
that architecture. The bug number MUST be placed in a comment, next to the
corresponding ExcludeArch line.

[FAIL] MUST: All build dependencies must be listed in BuildRequires, except for
any that are listed in the exceptions section of the Packaging Guidelines ;
inclusion of those as BuildRequires is optional. Apply common sense.

Like you wrote in the comment, you can remove packages that are dependencies of another package that you requires. 

[NA] MUST: The spec file MUST handle locales properly. This is done by
using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

[NA] MUST: Every binary RPM package (or subpackage) which stores shared
library files (not just symlinks) in any of the dynamic linker's default paths,
must call ldconfig in %post and %postun.

[PASS] MUST: Packages must NOT bundle copies of system libraries.

[NA] MUST: If the package is designed to be relocatable, the packager
must state this fact in the request for review, along with the rationalization
for relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker.

[FAIL] MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory.

%dir is not used in the %files section.

[FAIL]  MUST: A Fedora package must not list a file more than once in the spec
file's %files listings. (Notable exception: license texts in specific
situations)

No files are listed in the %files section.

[FAIL] MUST: Permissions on files must be set properly. Executables should be
set with executable permissions, for example.

No files are listed in the %files section.

[PASS] MUST: Each package must consistently use macros.

[PASS] MUST: The package must contain code, or permissable content.

[NA] MUST: Large documentation files must go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity). [18]
MUST: If a package includes something as %doc, it must not affect the runtime
of the application. To summarize: If it is in %doc, the program must run
properly if it is not present.

[NA] MUST: Static libraries must be in a -static package.

[NA] MUST: Development files must be in a -devel package. [20]
MUST: In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: Requires: %{name}%{?_isa} =
%{version}-%{release}

[PASS] MUST: Packages must NOT contain any .la libtool archives, these must be
removed in the spec if they are built.

[NA] MUST: Packages containing GUI applications must include a
%{name}.desktop file, and that file must be properly installed with
desktop-file-install in the %install section. If you feel that your packaged
GUI application does not need a .desktop file, you must put a comment in the
spec file with your explanation. 

[PASS] MUST: Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon. This
means, for example, that no package in Fedora should ever share ownership with
any of the files or directories owned by the filesystem or man package. If you
feel that you have a good reason to own a file or directory that another
package owns, then please present that at package review time. [23]

[FAIL] MUST: All filenames in rpm packages must be valid UTF-8.

Since I was unable to create the rpm files I couldn't verify this.
Comment 6 rudy.sicard 2012-03-09 12:57:29 EST
Hi,

Thank you for the review, and sorry for the delays.
Here are my comment and question.
The new spec and srpm and rpm are available at:
http://download.opalang.org/fedora-package-candidate/opa.spec
http://download.opalang.org/fedora-package-candidate/opa-0.9.0-2.fc17.src.rpm
http://download.opalang.org/fedora-package-candidate/opa-0.9.0-2.fc17.x86_64.rpm

I list all issues and give an "ANSWER" for each.
I finish by a summary.


BEGIN ISSUE
$ rpmlint opa.spec
opa.spec:106: W: macro-in-comment %buildroot
opa.spec: W: invalid-url Source0: opalang.tar.gz
0 packages and 1 specfiles checked; 0 errors, 2 warnings.

I think the Source0 should be a URL and not just the file name.

$ rpmlint opa-0.9.0-1.fc17.src.rpm
opa.src: W: name-repeated-in-summary C Opa
opa.src: W: no-version-in-last-changelog
opa.src:106: W: macro-in-comment %buildroot
opa.src: W: invalid-url Source0: opalang.tar.gz
1 packages and 0 specfiles checked; 0 errors, 4 warnings.
END ISSUE

BEGIN ANSWER
I changed Source0 to be a URL.

Note that the source can be a file name if the explanation of how to contruct file is present.
END ANSWER

BEGIN ISSUE
I was unable to build the binary package using mock:

+ rm -rf /builddir/build/BUILD/usr
+ ./install_release.sh -no-doc -keep-build -keep-install-sys -srcdir . -dir
/builddir/build/BUILD/usr
error: Bad exit status from /var/tmp/rpm-tmp.gqsfjf (%build)
    Bad exit status from /var/tmp/rpm-tmp.gqsfjf (%build)
END ISSUE

BEGIN ANSWER
Both RPM and SRPM build successfully on my x86_64 with fedora rawhide.

I have tried to used mock but did not manage to use it yet. I will retry mock and post the result.
END ANSWER

BEGIN ISSUE
[FAIL] MUST: The spec file for the package MUST be legible.

Can't you use %{_libdir} (or similar) macro?

No file names in %files section. I think "%{_bindir}/*" is too general and
probably includes all under /usr/bin directory.
END ISSUE

BEGIN ANSWER
I am not sure to understand what you mean.

Using %{_libdir} ? Where ?

I only used plain directory names to handle the lib/lib64 choice (by making lib64 pointing to lib in %_buildroot).
Everything else uses macros.

The upstream version always use lib, whereas fedora use lib or lib64 depending or the architeture.

%{_bindir}/* is used in the example in fedora wiki http://fedoraproject.org/wiki/How_to_create_an_RPM_package.
(see %files section)
END ANSWER

BEGIN ISSUE
[FAIL] MUST: The package MUST successfully compile and build into binary rpms
on at least one primary architecture.

[NA] MUST: If the package does not successfully compile, build or work
on an architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in
bugzilla, describing the reason that the package does not compile/build/work on
that architecture. The bug number MUST be placed in a comment, next to the
corresponding ExcludeArch line.
END ISSUE

BEGIN ANSWER
See previous about binary package and mock.
END ANSWER

BEGIN ISSUE
[FAIL] MUST: All build dependencies must be listed in BuildRequires, except for
any that are listed in the exceptions section of the Packaging Guidelines ;
inclusion of those as BuildRequires is optional. Apply common sense.

=> Like you wrote in the comment, you can remove packages that are dependencies of
another package that you requires.
END ISSUE

BEGIN ANSWER
I will do a pass to minimize dependencies.
END ANSWER

BEGIN ISSUE
[NA] MUST: The spec file MUST handle locales properly. This is done by
using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

[NA] MUST: Every binary RPM package (or subpackage) which stores shared
library files (not just symlinks) in any of the dynamic linker's default paths,
must call ldconfig in %post and %postun.

[NA] MUST: If the package is designed to be relocatable, the packager
must state this fact in the request for review, along with the rationalization
for relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker.
END ISSUE

BEGIN ISSUE
[FAIL] MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory.

%dir is not used in the %files section.

END ISSUE

BEGIN ANSWER
The section contains
%{_bindir}/*
%{_libdir}/%{name}
%{_datadir}/doc/%{name}
%{_datadir}/%{name}
%{_datadir}/man/man1/*

The package depends on pre-existence of system dir %{_bindir}, %{_datadir}/man/man1.
It creates %{_libdir}/%{name}, %{_libdir}/%{name}, %{_datadir}/doc/%{name} and own everything that is inside.

From what I know (http://www.rpm.org/max-rpm/s1-rpm-inside-files-list-directives.html),
%dir helps packaging a directory only (without content).

Should I separate the registering of directory and directory content ?
e.g. Convert
%files
%{_libdir}/%{name}
into
%files
%dir %{_libdir}/%{name}
 %{_libdir}/%{name}/*

END ANSWER

BEGIN ISSUE
[FAIL]  MUST: A Fedora package must not list a file more than once in the spec
file's %files listings. (Notable exception: license texts in specific
situations)

No files are listed in the %files section.
END ISSUE

BEGIN ANSWER
Sorry but I don't understand the problem here.
No files are listed twice.
END ANSWER

BEGIN ISSUE
[FAIL] MUST: Permissions on files must be set properly. Executables should be
set with executable permissions, for example.

No files are listed in the %files section.
END ISSUE

BEGIN ANSWER
To me the files already have appropriate permissions.
Theses permissions are not specified in the %files section but correctly set before this section (as in http://fedoraproject.org/wiki/How_to_create_an_RPM_package)
END ANSWER

BEGINE ISSUE
[NA] MUST: Large documentation files must go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity). [18]
MUST: If a package includes something as %doc, it must not affect the runtime
of the application. To summarize: If it is in %doc, the program must run
properly if it is not present.

[NA] MUST: Static libraries must be in a -static package.

[NA] MUST: Development files must be in a -devel package. [20]
MUST: In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: Requires: %{name}%{?_isa} =
%{version}-%{release}

[NA] MUST: Packages containing GUI applications must include a
%{name}.desktop file, and that file must be properly installed with
desktop-file-install in the %install section. If you feel that your packaged
GUI application does not need a .desktop file, you must put a comment in the
spec file with your explanation.
END ISSUE

BEGIN ISSUE
[FAIL] MUST: All filenames in rpm packages must be valid UTF-8.

Since I was unable to create the rpm files I couldn't verify this.
END ISSUE

BEGIN ANSWER
In my tests the package files have correct UTF-8 names.
END ANSWER

BEGIN SUMMARY
I have tried to answer all the issues.
I will upload a new spec file.
However I still need to test the package building using mock.
(it builds fine outside mock on my fedora 17)

Two questions:
 - is it appropriate to add a directory via %files when both the directory and its content are part of the package ?
 - it is legal to use %{bindir}\* in %files section when package only creates files inside the bin subdir ?
END SUMMARY
Comment 7 Steven Dake 2012-04-13 15:52:07 EDT
Rudy,

In comment #4, I asked you to review Bug #772608.  Since you didn't review that review request, I will have another package for you to review shortly.  The reasoning behind this is people in the packagers group should be able to review other packagers packages to help enhance fedora.

I will also have that package reviewer that needs a sponsor review your package and follow up on this review.
Comment 8 Steven Dake 2013-05-30 01:58:51 EDT
Rudy,

Are you still interested in being sponsored?  No contact since April 2012.  If I don't hear from you in next 15 days I'll step back from review and allow you to find a new sponsor.

Regards
-steve
Comment 9 Christopher Meng 2013-07-23 21:34:57 EDT
Hi reporter,

This is a friendly reminder that if you don't response for this ticket in next 2 weeks, I'll close this bug.

Thanks.
Comment 10 Thomas Spura 2013-11-22 02:28:12 EST
Feel free to reopen, if you change your mind and want to have this package included in Fedora.

Note You need to log in before you can comment on or make changes to this bug.